#property  copyright " March 2011 fosgate_r"
#property  link "http://forexfreeea.blogspot.com/"
#include <stdlib.mqh>

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern   string   stoplossHLineName      = "SL";
extern   string   profitTarget1HLineName = "PT1";
extern   string   profitTarget2HLineName = "PT2";
extern   int      Magic                  = 123321;
extern   string   EAcomment              = "DV_OrderMgmt";
extern   double   Lot                    = 0.01;
extern   int      NbPipsTolerance        = 1;
extern   int      Spread                 = 2;
extern   int      NbSleepingBars         = 15;
extern   int      tradeDirection         = 0;
extern   int      timeFrame              = PERIOD_M5;
extern   bool     activateTrailingStop   = true;
extern   bool     ShowComment            = true;
extern   bool     Debug                  = false;



// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //
int SIGNAL_BUF = 2;
int TRADE_DIR_UP = 1;
int TRADE_DIR_DOWN = -1;
int TRADE_DIR_NONE = 0;


double   stoplossPrice;
double   profitTarget1Price;
double   profitTarget2Price;
int      slippage = 3;

datetime lastTime;
datetime firstOrderTime;
int isSLinTheZone = false;


// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   lastTime = Time[2];
   firstOrderTime = NULL;
   
   isSLinTheZone = false;
   tradeDirection = TRADE_DIR_NONE;
   
   //findLastFractalUp();
   
   return(0);    
}


// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
{
   Comment("");
   return(0);
}


// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

void closeAllOrders(bool closePending, bool closeRunning, bool closeBuy, string closeWithSignal)
{
   int cnt,c,total=0,ticket=0,err=0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}
      
      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
               if (closeBuy && closeRunning) {
                  if (closeWithSignal == "" || (StringSubstr(OrderComment(),0,5) == closeWithSignal)) {
                     for(c=0;c<5;c++)
                     {
                        RefreshRates();
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                        err = GetLastError();
                        if (err==0)   break;
                        else
                        {
                           Print("Errors Closing BUY order");
                           Print(ErrorDescription(err),", error ",err);
                           if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                           { Sleep(5000); continue; }                            // Busy errors
                        }
                     }
                  }
               }   
               break;
         
            case OP_SELL:
               if (!closeBuy && closeRunning) {
                  if (closeWithSignal == "" || (StringSubstr(OrderComment(),0,5) == closeWithSignal)) {
                     for(c=0;c<5;c++)
                     {
                        RefreshRates();
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                        err = GetLastError();
                        if (err==0) break;
                        else
                        {
                           Print("Errors Closing SELL order");
                           Print(ErrorDescription(err),", error ",err);
                           if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                           { Sleep(5000); continue; }                            // Busy errors
                        }
                     }   
                  }
               }
               break;
              
            case OP_BUYSTOP:
               if (closeBuy && closePending) {
                  if (closeWithSignal == "" || (StringSubstr(OrderComment(),0,5) == closeWithSignal)) {
                     for(c=0;c<5;c++)
                     {
                        RefreshRates();
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                        err = GetLastError();
                        if (err==0)   break;
                        else
                        {
                           Print("Errors Closing BUY order");
                           Print(ErrorDescription(err),", error ",err);
                           if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                           { Sleep(5000); continue; }                            // Busy errors
                        }
                     }
                  }
               }   
               break;
               
            case OP_SELLSTOP:
               if (!closeBuy && closePending) {
                  if (closeWithSignal == "" || (StringSubstr(OrderComment(),0,5) == closeWithSignal)) {
                     for(c=0;c<5;c++)
                     {
                        RefreshRates();
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                        err = GetLastError();
                        if (err==0) break;
                        else
                        {
                           Print("Errors Closing SELL order");
                           Print(ErrorDescription(err),", error ",err);
                           if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                           { Sleep(5000); continue; }                            // Busy errors
                        }
                     }   
                  }
               }
               break;
         } // end of switch
      } // end of if
   } // end of for       
}

void closeOrderIfProfit()
{
   int cnt,c,total=0,ticket=0,err=0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==mgc && */OrderSymbol()==Symbol())
      {
         if (OrderProfit() > 0.0) {  
            switch(OrderType())
            {
               case OP_BUY:
                  for(c=0;c<5;c++)
                  {
                     RefreshRates();
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                     err = GetLastError();
                     if (err==0)   break;
                     else
                     {
                        Print("Errors Closing BUY order");
                        Print(ErrorDescription(err),", error ",err);
                        if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                        { Sleep(5000); continue; }                            // Busy errors
                     }
                  }   
                  break;
         
               case OP_SELL:
                  for(c=0;c<5;c++)
                  {
                     RefreshRates();
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                     err = GetLastError();
                     if (err==0) break;
                     else
                     {
                        Print("Errors Closing SELL order");
                        Print(ErrorDescription(err),", error ",err);
                        if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                        { Sleep(5000); continue; }                            // Busy errors
                     }
                  }   
                  break;
            } // end of switch
         }
      } // end of if
   } // end of for       
}

int start() {
   
   Process();
   
}

int Process() {
   
   setTradeDirection();
   
   // Fractal Breakout Entry
   updateFBOrders();
   
   
   return(0);
}

double getSignal(string indicatorName, int shift) {
   return(iCustom(NULL,0,indicatorName,5,200,SIGNAL_BUF,shift));
}


// ------------------------------------------------------------------------------------------ //
//                        E N D   O F   E X P E R T   A D V I S O R                           //
// ------------------------------------------------------------------------------------------ //

// ------------------------------------------------------------------------------------------ //
//                        OPEN ORDER                                                          //
// ------------------------------------------------------------------------------------------ //

int OPENORDER(string ord,double price,double SL,double TP,string comment)
{
   int error,err;
   while (true)
   {  error=true;
      if (ord=="BuyStop" ) error=OrderSend(Symbol(),OP_BUYSTOP, Lot,NormalizeDouble(price,Digits),slippage,SL,TP,comment,Magic,3,Blue);
      if (ord=="SellStop") error=OrderSend(Symbol(),OP_SELLSTOP,Lot,NormalizeDouble(price,Digits),slippage,SL,TP,comment,Magic,3,Red);
      if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(price,Digits),slippage,SL,TP,comment,Magic,3,Blue);
      if (ord=="Sell") error=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(price,Digits),slippage,SL,TP,comment,Magic,3,Red);
      if (error==-1)
      {  
         ShowERROR();
         err++;Sleep(2000);RefreshRates();
      }
      if (error || err >10) return(error);
   }
return(error);
}                  
//--------------------------------------------------------------------
void ShowERROR()
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:   return;
      default:  Alert("Error  " ,err," ",Symbol());return;
   }
}
//--------------------------------------------------------------------

// ------------------------------------------------------------------------------------------ //
//                        ORDER STOPLOSS MANAGEMENT                                           //
// ------------------------------------------------------------------------------------------ //

int findLastFractalUp() {
   double fractal = 0.0;
   int pos = 2;
   double lips = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, 0);
   double teeth = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, 0);
   double jaw = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, 0);
   
   double maxAlligator = getMaxAlligator(lips, teeth, jaw);
    
   while (fractal == 0.0/* || fractal < maxAlligator*/) {
      pos++;
      fractal = iFractals(NULL, 0, MODE_UPPER, pos);  
   }
   
   if (fractal > maxAlligator)
      return(pos);
   else
      return(-1);
}

int findLastFractalDown() {
   double fractal = 0.0;
   int pos = 2;
   double lips = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, 0);
   double teeth = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, 0);
   double jaw = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, 0);
   
   double minAlligator = getMinAlligator(lips, teeth, jaw);
    
   while (fractal == 0.0/* || fractal > minAlligator*/) {
      pos++;
      fractal = iFractals(NULL, 0, MODE_LOWER, pos);  
   }
   if (fractal < minAlligator)
      return(pos);
   else
      return(-1);
}

double getMaxAlligator(double lips, double teeth, double jaw) {
   double max = lips;
   
   if (teeth > max) max = teeth;
   if (jaw > max) max = jaw;
   
   return(max);
}

double getMinAlligator(double lips, double teeth, double jaw) {
   double min = lips;
   
   if (teeth < min) min = teeth;
   if (jaw < min) min = jaw;
   
   return(min);
}

void updateFBOrders() {
   int upFractalPos = findLastFractalUp();
   int downFractalPos = findLastFractalDown();
   
   double upFractalTriggerLevel = 0.0;
   double downFractalTriggerLevel = 0.0;
   double longSL = 0.0;
   double shortSL = 0.0;
   
   int cnt,c,total=0,ticket=0,err=0;
   
   bool hasBuyOrder = false;
   bool hasSellOrder = false;
   
   if (Debug) Alert("Up Fractal Position: " + upFractalPos);
   if (Debug) Alert("Down Fractal Position: " + downFractalPos);
   
   if (upFractalPos != -1) {
      upFractalTriggerLevel = NormalizeDouble(High[upFractalPos] + NbPipsTolerance*Point*10 + Spread*Point*10, Digits);
      /*double val = NormalizeDouble(Point, Digits);
      Alert("val:" + val);
      Alert("pips tolrence:" + NormalizeDouble(NbPipsTolerance*Point*10, Digits));
      Alert("spread:" + NormalizeDouble(spread()*Point, Digits));
      Alert(upFractalTriggerLevel);*/
      shortSL = upFractalTriggerLevel;
      if (Debug) Alert("Short Stop: " + shortSL);
   }
      
   if (downFractalPos != -1) {
      downFractalTriggerLevel = NormalizeDouble(Low[downFractalPos] - (NbPipsTolerance*Point*10), Digits);
      longSL = downFractalTriggerLevel;
      if (Debug) Alert("Long Stop: " + longSL);  
   }
   
   
   int orderType;
   total = OrdersTotal();
   Alert("Nb Total orders = " + total);
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS)) {Sleep(500);}
      orderType = OrderType();
      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {      
         if ((orderType == 0 || orderType == 4)) {
            if (!(isSLinTheZone && areBuyOrdersInProfitAt(NormalizeDouble(Low[1] - NbPipsTolerance*Point*10,Digits))))
               if (NormalizeDouble(OrderStopLoss(), Digits) != longSL) { 
                  if (Debug) {
                     Alert("LongSL: " + longSL);
                     Alert("Order SL: " + NormalizeDouble(OrderStopLoss(), Digits));
                     Alert("Modif required");
                     Alert("Count: " + cnt + " Stoploss " + longSL + " for buy order: " + OrderTicket() + " orderType: " +OrderType());
                  }
                  OrderModify(OrderTicket(), OrderOpenPrice(), longSL, OrderTakeProfit(),0, Yellow);
                  //cnt = total-1;
               }
         }
         
         if ((orderType == 1 || orderType == 5)) { 
            if (!(isSLinTheZone && areSellOrdersInProfitAt(NormalizeDouble(High[1] + NbPipsTolerance*Point*10 + Spread*Point*10,Digits))))
               if (NormalizeDouble(OrderStopLoss(), Digits) != shortSL) { 
                  if (Debug) {
                     Alert("ShortSL: " + shortSL);
                     Alert("Order SL: " + NormalizeDouble(OrderStopLoss(), Digits));
                     Alert("Modif required");
                     Alert("Count: " + cnt + " Stoploss " + shortSL + " for sell order: " + OrderTicket() + " orderType: " +OrderType());
                  }
                  OrderModify(OrderTicket(), OrderOpenPrice(), shortSL, OrderTakeProfit(),0, Yellow);
                  //cnt = total-1; 
               }
         }   
      } // end of if
   } // end of for
   
   if (tradeDirection == TRADE_DIR_UP && !hasBuyOrderForSignal("FB", upFractalPos)) {   
      if (upFractalTriggerLevel != 0.0) {
         hasBuyOrder = false;
         total = OrdersTotal();
         for(cnt = total-1; cnt >= 0; cnt--)
         {
            while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

            if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol() && getOrderSignalName(OrderComment()) == "FB")
            {
               switch(OrderType())
               {
                  case OP_BUYSTOP:
                     if (NormalizeDouble(OrderOpenPrice(), Digits) != upFractalTriggerLevel || NormalizeDouble(OrderStopLoss(), Digits) != longSL) {
                        OrderDelete(OrderTicket());
                        //OrderModify(OrderTicket(), upFractalTriggerLevel, longSL, OrderTakeProfit(),0, Yellow); 
                     }
                     else {
                        hasBuyOrder = true;
                     }
                     break;
               } // end of switch
            } // end of if
         } // end of for
   
         // open buy or sell order if one does not exist yet
         if (!hasBuyOrder) {
            if (Close[0] < upFractalTriggerLevel) 
               OPENORDER("BuyStop",upFractalTriggerLevel,longSL,0.0,"FB-" + TimeToStr(Time[upFractalPos]));
            else
               OPENORDER("Buy",NormalizeDouble(Ask, Digits),longSL,0.0,"FB-" + TimeToStr(Time[upFractalPos]));     
         }
      }
   } 
   
   if (tradeDirection == TRADE_DIR_DOWN && !hasSellOrderForSignal("FB", downFractalPos)) {  
      if (downFractalTriggerLevel != 0.0) {
         hasSellOrder = false;
         total = OrdersTotal();
         for(cnt = total-1; cnt >= 0; cnt--)
         {
            while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

            if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol() && getOrderSignalName(OrderComment()) == "FB")
            {
               switch(OrderType())
               {
                  case OP_SELLSTOP:
                     if (NormalizeDouble(OrderOpenPrice(), Digits) != downFractalTriggerLevel || NormalizeDouble(OrderStopLoss(), Digits) != shortSL) {
                        OrderDelete(OrderTicket());
                        //OrderModify(OrderTicket(), downFractalTriggerLevel, shortSL, OrderTakeProfit(),0, Yellow); 
                     }
                     else {
                        hasSellOrder = true;
                     }
                     break;
               } // end of switch
            } // end of if
         } // end of for
   
         // open buy or sell order if one does not exist yet
         if (!hasSellOrder) {
            if (Close[0] > downFractalTriggerLevel) 
               OPENORDER("SellStop",downFractalTriggerLevel,shortSL,0.0,"FB-" + TimeToStr(Time[downFractalPos]));
            else
               OPENORDER("Sell",NormalizeDouble(Bid, Digits),shortSL,0.0,"FB-" + TimeToStr(Time[downFractalPos]));         
         } 
      }
   }
   
   if (isAlligatorSleeping()) {
      hasBuyOrder = false;
      hasSellOrder = false;
   
      total = OrdersTotal();
      for(cnt = total-1; cnt >= 0; cnt--)
      {
         while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

         if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol() && getOrderSignalName(OrderComment()) == "FB")
         {
            switch(OrderType())
            {
               case OP_BUYSTOP:
                  if (NormalizeDouble(OrderOpenPrice(), Digits) != upFractalTriggerLevel || NormalizeDouble(OrderStopLoss(), Digits) != longSL) {
                     Alert("Not same values");
                     Alert("OrderOpenPrice: " + OrderOpenPrice());
                     Alert("upFractalTriggerLevel: " + upFractalTriggerLevel);
                     Alert("OrderStoploss: " + OrderStopLoss());
                     Alert("Fractal SL: " + longSL);
                     OrderDelete(OrderTicket());
                     //OrderModify(OrderTicket(), upFractalTriggerLevel, longSL, OrderTakeProfit(),0, Yellow); 
                  }
                  else {
                     hasBuyOrder = true;
                  }
                  break;
      
               case OP_SELLSTOP:
                  if (NormalizeDouble(OrderOpenPrice(), Digits) != downFractalTriggerLevel || NormalizeDouble(OrderStopLoss(), Digits) != shortSL) {
                     OrderDelete(OrderTicket());
                     //OrderModify(OrderTicket(), downFractalTriggerLevel, shortSL, OrderTakeProfit(),0, Yellow); 
                  }
                  else {
                     hasSellOrder = true;
                  }
                  break;
            } // end of switch
         } // end of if
      } // end of for
   
      // open buy or sell order if one does not exist yet
      if (!hasBuyOrder && !hasBuyOrderForSignal("FB", upFractalPos) && upFractalTriggerLevel != 0.0) {
         if (Close[0] < upFractalTriggerLevel) {
            OPENORDER("BuyStop",upFractalTriggerLevel,longSL,0.0,"FB-" + TimeToStr(Time[upFractalPos]));
            //Alert("Signal type: " + getOrderSignalName("FB-" + upFractalPos) + "at bar " + getOrderSignalPos("FB-" + upFractalPos));
         }
         else
            OPENORDER("Buy",NormalizeDouble(Ask, Digits),longSL,0.0,"FB-" + TimeToStr(Time[upFractalPos]));     
      }
   
      if (!hasSellOrder && !hasSellOrderForSignal("FB", downFractalPos) && downFractalTriggerLevel != 0.0) {
         if (Close[0] > downFractalTriggerLevel) {
            OPENORDER("SellStop",downFractalTriggerLevel,shortSL,0.0,"FB-" + TimeToStr(Time[downFractalPos]));
            //Alert("Signal type: " + getOrderSignalName("FB-" + downFractalPos) + "at bar " + getOrderSignalPos("FB-" + downFractalPos));
         }
         else
            OPENORDER("Sell",NormalizeDouble(Bid, Digits),shortSL,0.0,"FB-" + TimeToStr(Time[downFractalPos]));         
      }    
   }
}

void resetParameters() {
   isSLinTheZone = false;
   firstOrderTime = NULL;
}

bool areBuyOrdersInProfit() {
   int cnt,c,total=0,ticket=0,err=0;
   
   double totalProfit = 0.0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
               totalProfit = totalProfit + OrderProfit();
               break;
         } // end of switch
      } // end of if
   } // end of for
   
   return(totalProfit > 0.0);         
}

bool areBuyOrdersInProfitAt(double level) {
   int cnt,c,total=0,ticket=0,err=0;
   
   double totalProfit = 0.0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
               totalProfit = totalProfit + ((level - OrderOpenPrice()) * OrderLots());
               break;
         } // end of switch
      } // end of if
   } // end of for
   
   return(totalProfit > 0.0);         
}

bool areSellOrdersInProfit() {
   int cnt,c,total=0,ticket=0,err=0;
   
   double totalProfit = 0.0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_SELL:
               totalProfit = totalProfit + OrderProfit();
               break;
         } // end of switch
      } // end of if
   } // end of for
   
   return(totalProfit > 0.0);    
}

bool areSellOrdersInProfitAt(double level) {
   int cnt,c,total=0,ticket=0,err=0;
   
   double totalProfit = 0.0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_SELL:
               totalProfit = totalProfit + ((OrderOpenPrice() - level) * OrderLots());
               break;
         } // end of switch
      } // end of if
   } // end of for
   
   return(totalProfit > 0.0);         
}

void setTradeDirection() {
   if (tradeDirection == TRADE_DIR_NONE && getNbBuyOrders() >= 1) {
      tradeDirection = TRADE_DIR_UP;
      firstOrderTime = getOrderOpenTime(true);
   }
   else if (tradeDirection == TRADE_DIR_NONE && getNbSellOrders() >= 1) {
      tradeDirection = TRADE_DIR_DOWN;
      firstOrderTime = getOrderOpenTime(false);
   }
   else if (getNbBuyOrders() == 0 && getNbSellOrders() == 0) {
      tradeDirection = TRADE_DIR_NONE;
      resetParameters();
   }
   
   if (Debug) Alert("Trade Direction is: " + tradeDirection);
}

int getNbBuyOrders() {
   int cnt,c,total=0,ticket=0,err=0;
   
   int nbOrders = 0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
               nbOrders = nbOrders + 1;
               break; 
         } // end of switch
      } // end of if
   } // end of for  
   
   return(nbOrders);        
}

int getNbSellOrders() {
   int cnt,c,total=0,ticket=0,err=0;
   
   int nbOrders = 0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_SELL:
               nbOrders = nbOrders + 1;
               break; 
         } // end of switch
      } // end of if
   } // end of for  
   
   return(nbOrders);  
}

bool hasBuyOrderForSignal(string signalName, int signalPos) {
   int cnt,c,total=0,ticket=0,err=0;
   
   bool orderExist = false;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
            case OP_BUYSTOP:
               //Alert("Signal type: " + getOrderSignalName(OrderComment()) + "at bar " + getOrderSignalPos(OrderComment()));
               if (getOrderSignalName(OrderComment()) == signalName && getOrderSignalTime(OrderComment()) == Time[signalPos])
                  orderExist = true;
               break; 
         } // end of switch
      } // end of if
   } // end of for  
   
   return(orderExist);        
}

bool hasSellOrderForSignal(string signalName, int signalPos) {
   int cnt,c,total=0,ticket=0,err=0;
   
   bool orderExist = false;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_SELL:
            case OP_SELLSTOP:
               if (getOrderSignalName(OrderComment()) == signalName && getOrderSignalTime(OrderComment()) == Time[signalPos])
                  orderExist = true;
               break; 
         } // end of switch
      } // end of if
   } // end of for  
   
   return(orderExist);  
}

string getOrderSignalName(string orderName) {
   return(StringSubstr(orderName, 0, 2));
}

datetime getOrderSignalTime(string orderName) {
   return(StrToTime(StringSubstr(orderName, 3, StringLen(orderName)-3)));
}

datetime getOrderOpenTime(bool buy) {
   int cnt,c,total=0,ticket=0,err=0;
   
   int nbOrders = 0;
   
   total = OrdersTotal();
   for(cnt = total-1; cnt >= 0; cnt--)
   {
      while (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {Sleep(500);}

      if(/*OrderMagicNumber()==Magic &&*/ OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY:
               if (buy) {
                  return(OrderOpenTime());
               }
               break; 
               
            case OP_SELL:
               if (!buy) {
                  return(OrderOpenTime());
               }
               break;
         } // end of switch
      } // end of if
   } // end of for  
   
   return(NULL);     
}

bool isAlligatorSleeping() {
   bool isSleeping = false;
   int i = 1;
   
   while (!isSleeping && i <= NbSleepingBars) {
      double lips = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, i - 3);
      double teeth = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, i - 3);
      double jaw = iAlligator(NULL,0,13,8,8,5,5,3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, i - 3);
      
      if ((lips < teeth && jaw < teeth) || (lips > teeth && jaw > teeth)) {
         isSleeping = true;
      }
      
      i++;
   } 
   
   return(isSleeping);
}

         